/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\ ABOUT.C \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\ SOURCE C du module de GESTION \\\\\\\\\\\\\\\\\\\*/
/*                    de la boite d'information                        */
/*                         du programme                                */
 
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ I N C L U D E S \\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*..................... INCLUDES DES AUTRES MODULES DU PROGRAMME ......*/
#include "EAZY_GEM.H"  /* inclure les definitions des fonctions que le */
                       /* que le module EAZY_GEM.C met  notre         */
                       /* notre disposition                            */
                       /* et inclure les definitions des variables     */
                       /* globales  EAZY_GEM                           */

#include "PCSTUDIO.SYS\ABOUT.H"    /* symboles du ressource          */

#define W_ABOUT       5     /* (identificateur ou type) de la Fenetre   */

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\ P R O T O T Y P E S  F O N C T I O N S \\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
void ActiveABOUT(void);
void ActiveABOUT_wind(INT16 ident, long attr, char *title, CALLBACK (*w_proc)(INT16 w_ind, EVNT_O *Evnt));
CALLBACK WindProcABOUT(INT16 w_ind, EVNT_O *Evnt);

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                A   C O M M E N C E   I C I   !!!!                   */
/*              Definition des fonctions de ce module                   */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*------------------------------ WindProcABOUT ---------------------------*/
/* Affiche la boite d'information du programme                           */
CALLBACK WindProcABOUT(INT16 w_ind, EVNT_O *Evnt)
{/*....recuperer l'adresse du premier objet (racine) de la ressource....*/
 OBJECT *object = GETWINDTREE(w_ind); /* adr. arbre integre en fenetre  */
 INT16      w_h = GETGEMHAND(w_ind); /* handle GEM de notre fenetre    */
 /*.... recuperer handle fenetre avant plan (besoin apres)..............*/
 INT16   wh_top = GetTopWind(); /* recuperer handle fen. avt plan.      */
 
 if (Evnt->evnt & MU_KEYBD && w_h==wh_top)
    {INT16 i;
     char scan;  
     GRECT grect;          /* rectangle surface de travail                   */
     grect = Windtab[w_ind].GemWorkGrect;
     scan=(char)(Evnt->key>>8);
     switch(scan)
       {case  80:     /* down */
        case  72:     /* up   */
          if (Evnt->ksp & (K_RSHIFT|K_LSHIFT))
             {GetScrollBoxParam(object,INFO_SCROLL,0L,0L,0L,0L,0L,0L,0L,0L,0L,&i);
              if (scan!=80) i=-i;
              DoScrollBoxSlide (object, INFO_SCROLL,i,0,&grect);
              object[INFO_ASC].ob_y = VascPosAdjust(object, INFO_SCROLL, INFO_BAR, INFO_ASC); 
              Xobjc_draw(object, INFO_BAR, 1, &grect);                                     
             }
          else 
             {if (scan==80) i= 1;
              else          i=-1;
              DoScrollBoxSlide (object, INFO_SCROLL,i,0,&grect);
              object[INFO_ASC].ob_y = VascPosAdjust(object, INFO_SCROLL, INFO_BAR, INFO_ASC); 
              Xobjc_draw(object, INFO_BAR, 1, &grect);                                     
             }
          break;
        case 71:     /* clr home  */
          if (Evnt->ksp & (K_RSHIFT|K_LSHIFT))
             {INT16 nblt,    /* nbr de lignes total document                 */
                  nb_l;    /* nbr de lignes affichables par la scroll box  */
              GetScrollBoxParam (object, INFO_SCROLL,0L,0L,&nblt,0L,0L,0L,0L,0L,0L,&nb_l); 
              SetScrollBoxParam (object, INFO_SCROLL,-2,-2,-2,-2,nblt-nb_l,-2,-2,-2,(void*)-2L,-2);  
             }
          else
             {SetScrollBoxParam (object, INFO_SCROLL,-2,-2,-2,-2,0,-2,-2,-2,(void*)-2L,-2); 
             }
          object[INFO_ASC].ob_y = VascPosAdjust(object, INFO_SCROLL, INFO_BAR, INFO_ASC); 
          Xobjc_draw(object, INFO_BAR, 1, &grect);  
          Xobjc_draw(object, INFO_SCROLL, 1, &grect);
          break;
       } /*end switch scan  */
    }
    
 if (Evnt->evnt & MU_BUTTON )
    {INT16 ob_ret = Xform_button(w_ind, Evnt);
     if (ob_ret == INFO_SCROLL)
        {Evnt->evnt &= ~MU_BUTTON;   /* empecher propagation message  MU_BUTTON */
         /*............. si objet exit selectionne ...................*/
         object[ob_ret&0x7FFF].ob_state &= ~SELECTED;
         SendWindMessage(w_h, WM_CLOSED, 0L);
        }
    } /* endif MU_BUTTON  et fenetre au premier plan */

 if (Evnt->evnt & MU_TIMER && w_h==wh_top)  Xform_timer(w_ind, Evnt);    
 if (Evnt->evnt & MU_MOVE)                  Xform_mu_move(w_ind, Evnt);     
 if (Evnt->evnt & MU_MESAG)
    {switch (Evnt->pipe[MESG])
       {case WM_CONSTRUCT:
             if (WindDialogConstruct(w_ind, 
                                     LoadAppliRsc( "ABOUT.RSC", NO_SCALE), 0, RSC_DIAL, Evnt
                                    ) == WM_ABORT
                ) return WM_ABORT;     
             AdjustWindCoordToScreen (w_ind, Evnt, (GRECT*)&Evnt->pipe[X_B]); 
             break;
                                          
        case WM_DESTRUCT:         Xform_Destruct(w_ind, Evnt);    
                                  RscFicUnLoad(Windtab[w_ind].DlgVar.AdrRsc);         break;
        case WM_TT_ON_OFF:        SetBulleState(w_h, object);                         break;
        case WM_REDRAW:           Lister_rectangles(w_h,(GRECT*)&Evnt->pipe[X_G]);    break;
        case WM_BOTTOM:           wind_set(w_h, WF_BOTTOM , 0,0,0,0);                          break;
        case WM_TOPPED:           wind_set(w_h, WF_TOP, 0,0,0,0 );                             break;
        case WM_CLOSED:           DestroyWindow(w_h);                                 break;
        case WM_ALLICONIFY:       AllIconify((GRECT*)& Evnt->pipe[X_G]);              break;
        case WM_ICONIFY:          IconifyWindow(w_ind, (GRECT*)& Evnt->pipe[X_G]);    break;
        case WM_UNICONIFY:        UnconifyWindow(w_ind);                              break;
        case WM_SIZED:
        case WM_MOVED:            Xform_moved(w_ind, Evnt);                           break;
       }
    }      
 return Evnt->evnt;    /* retourner le flux evenementiel (modifie ou pas)    */
}

/*-------------------------- ActiveWindow ----------------------------------*/
void ActiveABOUT(void)
{ActiveABOUT_wind(W_ABOUT, XMOVER|XBORDER, "A propos", WindProcABOUT);
}
/*-------------------------- ActiveWindow ----------------------------------*/
void ActiveABOUT_wind(INT16 ident, long attr, char *title, CALLBACK (*w_proc)(INT16 w_ind, EVNT_O *Evnt))
{INT16 w_ind;
 w_ind = IsWindExist(ident);
 if (w_ind==-1)                 /* << SI existe pas la creer         */
    { INT16 w_h = CreateWindow(0x8000|attr, ident,0L,w_proc, 0,20+((Ecran_h-20)>>1),Ecran_l,(Ecran_h-20)>>1, title);
      if (w_h==-3||w_h==-2) form_alert(1,"Plus de fenetres ");
    }
 else                           /* << SI elle existe                  */
    {if (Windtab[w_ind].w_flag & W_IS_ICON || 
         Windtab[w_ind].w_flag & W_IS_ALLICON
        )
        {UnconifyWindow(w_ind); 
        }
     else if (IsWindOpen(w_ind))     /*        SI ouverte la mettre au top */
        {wind_set(Windtab[w_ind].w_h, WF_TOP, 0,0,0,0);
        }
     else                       /*        SI pas ouverte l'ouvrir     */
        {OpenWindow(w_ind, &Windtab[w_ind].ExtGrectUse);
        } 
    } 
}