
#ifndef __MAKE_BFN__
#define __MAKE_BFN__
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\ P R O T O T Y P E S  F O N C T I O N S \\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
#define ACCO_END_NOT_FIND      1 
#define ACCO_DEB_NOT_FIND      2 
#define PARNTH_END_NOT_FIND    3 
#define PARNTH_DEB_NOT_FIND    4 
#define COMMENT_END_NOT_FIND   5 
#define COMMENT_DEB_NOT_FIND   6 
#define GUILLM_END_NOT_FIND    7 
#define GUILLM_DEB_NOT_FIND    8 
#define APPOST_END_NOT_FIND    9 
#define APPOST_DEB_NOT_FIND   10 
#define END_BCONST_NOT_FIND   11   /* la fin d'un constructeur de base non trouve   */
#define DEB_BCONST_NOT_FIND   12   /* le debut d'un constructeur de base non trouve */

/*........... Macro testant caracteres...................................*/
#define ISPTEOL(a)         (*(a)==13||*(a)==10)
#define ISPTBRK(a)         (*(a)=='\\'&&((a)[1]==13||(a)[1]==10))
#define ISPTDEBCOM(a)      (*(a)=='/'&&(a)[1]=='*')
#define ISPTCPPCOM(a)      (*(a)=='/'&&(a)[1]=='/')
#define ISPTENDCOM(a)      (*(a)=='*'&&(a)[1]=='/')
#define ISPTAPPOST(a)      (*(a)=='\'')
#define ISPTESCAPE(a)      (*(a)=='\\'&&(a)[1])
#define ISVARNAME(a)       (*(a)=='_'||isalnum(*(a)))


/*.................... ASM_BASE.S .....................................*/
extern INT16  ISDEBCOM(char *src);
extern INT16  ISENDCOM(char *src);
extern INT16  ISDEBSTRING(char *src);
extern INT16  ISENDSTRING(char *src);
extern long   FAST_CHARCPY(char *src, char *dst);

static char *LastAccol  = 0;

/*........... Flag d'erreur lors analyse source C ..........................*/
typedef struct {INT16 Flag;
                char *pt;
               }ERR_C;


char  *FindFunc(char *deb, char *pt, char **finfunc, ERR_C *err);
char  *FindDebFunc(char *deb, char *fstparenth, char**finfunc);
char  *FindFirstAcco(char *pt, ERR_C *err);
char  *GotoEndBConst(char *pt, ERR_C *err);
char  *GotoEndPrePro(char *pt, ERR_C *err);
char  *GotoEndParnth(char *pt, ERR_C *err);
char  *GotoEndAcolld(char *pt, ERR_C *err);
char  *GotoEndComent(char *pt, ERR_C *err);
char  *GotoEndGuillm(char *pt, ERR_C *err);
char  *GotoEndAppost(char *pt, ERR_C *err);
char  *GotoNextLigne(char *pt);
char  *EndOfLine(char *pt);
char  *DebOfLine(char *deb, char *pt);
char  *LoadFic( const char *path);
void  *Bload( char *path, char *name, void *adr_load);
char  *GotoFirstNonSpace(char *pt);

#endif
