/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\   WINDLIST.C    \\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/* Ce module est un des sources C de : PCSTUDIO.PRG                    */
/* Le fichier projet associ est:      PCSTUDIO.PRJ                    */
/* Gestion d'une fenetre liste d'options  cliquer:                    */

 
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ I N C L U D E S \\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*--------------------- INCLUDES DES AUTRES MODULES DU PROGRAMME -------*/
#include <EAZY_GEM.H>  /* inclure les definitions des fonctions que le  */

/*--------------------- INCLURE LES DEFINITIONS SYMBOLIQUES ------------*/
/*                      que l'diteur de ressource gnre               */
/*                      lors de la cration de la ressource             */
#include "PCSTUDIO.SYS\WINDLIST.H"
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ D E F I N E S  \\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                         TYPAGE DES FENETRES                          */
/*----------------------------------------------------------------------*/
 
#define W_PCSTUDIO    1     /* (identificateur ou type) de la Fenetre   */
#define W_CONFIG      2     /* (identificateur ou type) de la Fenetre   */
#define W_PEXEC3      3     /* (identificateur ou type) de la Fenetre   */
#define W_WINDLIST    4     /* (identificateur ou type) de la Fenetre   */

#define WM_UPDATE_CFG (WM_USER+123)

typedef struct
 {char *txt;
  char *pt;
  long ret;
 } LISTBOX_IN_OUT;
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\ V A R I A B L E S    G L O B A L E S \\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
extern char **TxtPtStrMess;
LISTBOX_IN_OUT *PLSTB_IO;
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\ P R O T O T Y P E S  F O N C T I O N S \\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*................ FONCTIONs DU FICHIER ACTUEL .........................*/
static void AdjustWINDLISTSlide(OBJECT *object);
static void UpdateWINDLISTTexte( OBJECT *object, INT16 ob_ind, TXTED_OB *TXT_A);
void AdjustRscToNewGrectWind(long w_attr, OBJECT *object, GRECT *oldGrect,  GRECT *newGrect);
INT16  GetWindDeltaY(INT16 kind);

INT16 OnMouseList(INT16 w_ind, TXTED_OB  *TXT_A, long x, long y);

/*................ FONCTIONS CALLBACK DE FENETRES ......................*/
 CALLBACK WindProcWINDLIST(INT16 w_ind, EVNT_O *Evnt);

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                A   C O M M E N C E   I C I   !!!!                   */
/*              Definition des fonctions de ce module                   */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*------------------------------ WindProcPEXEC3 ----------------------------*/
CALLBACK WindProcWINDLIST(INT16 w_ind, EVNT_O *Evnt)
{OBJECT *object   = GETWINDTREE(w_ind); 
 INT16 wh_top     = GetTopWind();
 INT16 w_h        = GETGEMHAND(w_ind);  /* celui GEM de notre fenetre     */
 /*............................Rpondre  l'vnement MU_KEYBD .........*/
 if (Evnt->evnt & MU_KEYBD && w_h == wh_top)
    {Xform_keybd(w_ind, Evnt);
    }
    
 /*.......................... Rpondre  l'vnement MU_BUTTON .........*/ 
 
 if (Evnt->evnt & MU_BUTTON)
    {INT16     ob_ret = -1;
     TXTED_OB  *TXT_A = EZ_ED_GetTxtEditStruct(object, LISTBOX_TXTED);
     if (!IsMouseXYInGrect( Evnt->x, Evnt->y, &Windtab[w_ind].ExtGrectUse)) 
         {SendWindMessage(GETGEMHAND(w_ind), WM_MODAL_END, 0);
          return 0;
         }

     if ( OnMouseList(w_ind, TXT_A,  Evnt->x, Evnt->y) == -1)
        {ob_ret = Xform_button(w_ind, Evnt); /* recuperer objet clique */
        }
     else Evnt->evnt &= ~MU_BUTTON;  
     if (ob_ret>-1)            /*<<<<SI UN OBJET EST CLIQUE >>>>>>>>>>>*/
        {/*.... empecher propagation message  MU_BUTTON ...............*/
         /*     de faon  ce qu'il ne soit pas possible de            */
         /*     cliquer sur deux fenetres  la fois.                   */
         Evnt->evnt &= ~MU_BUTTON;  
         
         /*.......le remettre en non selectionn et le redessiner......*/
         object[ob_ret].ob_state &= ~SELECTED;  
         if (object[ob_ret].ob_type &((G_CICON<<8)|G_USERDEF))
             SendObjectRedraw( w_h, object, ob_ret); 
         else
             Wobjc_draw(w_ind,object, ob_ret, 3, 0);
         
         /*.............. ICI ACTION SELON BOUTON CLIQUE..............*/
         /* j'ai mis en commentaire comment il est possible de tester */
         /* et lancer une action selon l'objet cliqu. Utilisez les   */
         /* symboles du fichier .H de la ressource (ici EZ_INFO.H) afin */
         /* de rendre votre programme plus lisible.                   */
                     
          switch (ob_ret)
            {
            }
        }  /* endif objet selectable cliqu  */ 
    } /* endif MU_BUTTON  et fenetre au premier plan */
 
 /*.......................... Rpondre  l'vnement MU_TIMER.............*/
 if (Evnt->evnt & MU_TIMER)  
    {if (w_h == wh_top ) Xform_timer(w_ind, Evnt);    
    }
   
 /*..........................Rpondre  l'vnement MU_MOVE ..............*/
 if (Evnt->evnt & MU_MOVE)   /*  (EZGEM evenement)   */
    {Xform_mu_move(w_ind, Evnt);
    }       
    
 /*..........................Rpondre aux messages MU_MESAG ..............*/
 if (Evnt->evnt & MU_MESAG)
    {switch (Evnt->pipe[MESG])
       {case WM_EDIT_UPDATE:
             /**************************************************************/
             /*................ WM_EDIT_UPDATE (EZ_GEM message)............*/
             /* Ce message est envoy a notre procedure de fenetre lorsque */
             /* un editeur de texte lui notifie un changement succeptible  */
             /* d'entrainer une mise a jour de la fenetre, ou lui notifie  */
             /* une action future pouvant etre modifiee.                   */
             /* en Evnt->pipe[X_G] se trouve la nature de la notification  */
             /* si egal a:                                                 */
            {TXTED_OB* TXT_A  = (TXTED_OB*) *(long*)&Evnt->pipe[W_G];
             EVNT_O *Evnt_txt = (EVNT_O*)   *(long*)&Evnt->pipe[X_B]; 
             switch(Evnt->pipe[X_G])
               {/*..... ED_CLICK_IN (il a ete clique dans le texte)...............*/
                /* en:    *(long*)&Evnt->pipe[W_G] adresse de l'editeur de texte  */
                /*        *(long*)&Evnt->pipe[X_B] variable de flux evenementiel  */
                /* Si il est retourne 0  ce message, l'editeur de texte ne       */
                /* ne recevra pas l'evenement.                                    */
                case ED_CLICK_IN:
                    {/*.................. BOUTON DROIT ...........................*/
                     if (Evnt->k == 2)  
                        {return 0;
                        }
                     else
                        {OnMouseList(w_ind, TXT_A, Evnt_txt->x, Evnt_txt->y);
                        }
                    } break;
                /*.......  ED_KEYB_DWN (une touche CLAVIER a ete appuyee)..........*/
                /* en:    *(long*)&Evnt->pipe[W_G] adresse de l'editeur de texte  */
                /*        *(long*)&Evnt->pipe[X_B] variable de flux evenementiel  */ 
                /* Si il est retourne 0  ce message, l'editeur de texte ne       */
                /* ne recevra pas l'evenement.                                    */
                case ED_KEYB_DWN:
                case ED_KEYB_CNTRL:
                case ED_KEYB_ALT:
                    {char scan  = (char)(Evnt_txt->key>>8);
                     /*....... n'autoriser que CNTRL C et CTRL A .............*/
                     if (Evnt->pipe[X_G] == ED_KEYB_CNTRL ||
                         Evnt->pipe[X_G] == ED_KEYB_ALT
                        )
                        {char car  = (char)ScanToAscii(Evnt_txt->key, Evnt_txt->ksp);
                         if (strchr("aAcC",car)) return 1;
                         else                    return 0;
                        }
                     /*....... n'autoriser que les touches flechees ..........*/
                     switch(scan)
                        {case 0x1C:      /* ENTER                      */
                         case 0x72:      /* RETURN    Activer la ligne */
                              {char *pt      = EZ_ED_GETCURLIG(TXT_A);
                               PLSTB_IO->pt  = pt;
                               PLSTB_IO->ret = TXT_A->LigPt;
                               while (*pt && *pt ==' ') pt++;
                               if (*pt==0||*pt=='\r')
                                  {PLSTB_IO->pt       = 0;
                                   PLSTB_IO->ret      = -1;
                                  }
                               SendWindMessage(GETGEMHAND(w_ind), WM_MODAL_END, 0);
                              }
                              return 0;
                         case 75:
                         case 72:
                         case 80:
                         case 77:
                         case 71:
                           return 1;
                         default:
                           /* wprintf( "Fenetre STD_OUT en lecture seulement\r\n" ); */
                           return 0;
                        }/* end switch */
                        
                    } /* endcase ED_KEYB_ALT: */
               } /* endswitch(Evnt->pipe[X_G]) */
       } /* end case WM_EDIT_UPDATE: */
                     return 1;
        
        case WM_CONSTRUCT:
            {TXTED_OB  *TXT_A;
             long       param[4];
             GRECT      *newGrect;
             GRECT      oldGrect;
             INT16      delt_y, wdy;
             PLSTB_IO  = (LISTBOX_IN_OUT*)Windtab[w_ind].UserPtr;
             /*......... charger et integrer la ressource ........*/
             if (WindDialogConstruct(w_ind, 
                                     LoadAppliRsc( "WINDLIST.RSC", NO_SCALE), 0, RSC_DIAL, Evnt
                                    ) == WM_ABORT
                ) return WM_ABORT;
             object = GETWINDTREE(w_ind);
             newGrect      = (GRECT*)&Evnt->pipe[X_B];
             oldGrect      = *newGrect;
             /*................ recuperer valeur d'entree et ..............*/
             /*                 initialiser valeurs de sortie              */
             if (PLSTB_IO->txt) ObjcSetTxt(object, LISTBOX_TXTED, PLSTB_IO->txt);
             PLSTB_IO->pt       = 0;
             
             TXT_A          =  EZ_ED_GetTxtEditStruct(object, LISTBOX_TXTED);
             TXT_A->State  |=  EDIT_MOFORM_ARROW;
             newGrect->g_w += 100;
             delt_y         = object[WINDLIST].ob_height - object[LISTBOX_TXTED].ob_height;
             wdy            = GetWindDeltaY((INT16)Windtab[w_ind].w_attr);
             if (PLSTB_IO->ret) newGrect->g_h = Min(Ecran_h - 30, ((INT16)PLSTB_IO->ret+1) * (TXT_A->IntLg) + (RSC_PLUS<<1) + delt_y + wdy);
             PLSTB_IO->ret  = -1;
             AdjustRscToNewGrectWind(Windtab[w_ind].w_attr, object, &oldGrect, newGrect);
             
             /*........... ajuster taille ascensseur .......................*/
             AdjustWindCoordToScreen (w_ind, Evnt, (GRECT*)&Evnt->pipe[X_B]);
             SetScrollBoxParam (object,   /* adresse de l'arbre dans lequel est l'objet      */
                          LISTBOX_TXTED,  /* indice de l'objet dans l'arbre                  */
                          -2,             /* hauteur en pixels d'une ligne de scrolling      */
                          -2,             /* largeur en pixels d'une colonne scrolling       */
                          -2L,            /* Nombre total de lignes document                 */
                          -2L,            /* nombre total de colonnes document               */
                          0,              /* indice ligne document  afficher en 1er         */
                          0,              /* indice colonne document  afficher  gauche     */
                          -2L,            /* ligne selectionne ( mettre en surbrillance)   */
                          -2L,            /* colonne selectionne ( mettre en surbrillance) */
                          (void*)-2L,     /* paramtre optionnel  type de pointeur          */
                          -2
                         );
             
             VascHeightAdjust(object, LISTBOX_TXTED, LISTBOX_VERT_BAR, LISTBOX_VERT_ASC);
             UpdateWINDLISTTexte(object, LISTBOX_TXTED, TXT_A);
             param[0] = (long)(TXT_A->ptTxt);
             param[1] = (long)TXT_A;
             EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CLEAR_SEL,    (INT16*)param, 4, TXT_A);
             EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_CURS_POS, (INT16*)param, 4, TXT_A);
             break;
            }
        case WM_DESTRUCT:       /*  (EZGEM message)   */
            {Xform_Destruct(w_ind, Evnt);    
             RscFicUnLoad(Windtab[w_ind].DlgVar.AdrRsc);
            }
             break;
        case WM_TT_ON_OFF:      /*  (EZGEM message)   */
             SetBulleState(w_h, GETWINDTREE(w_ind));
             break;
        case WM_TT_GET_TXT:     /*  (EZGEM message)   */
             /**************************************************************/
             /*...................... WM_TT_GET_TXT .(EZGEM message).......*/
             /* Ce message est envoy a notre procedure de fenetre chaque  */
             /* fois que le systeme d'affichage d'une bulle d'aide desire  */
             /* qu'on lui fournisse un texte  afficher.                   */
             /* Ce texte peut etre affiche sur plusieurs lignes en mettant */
             /* comme separateur le signe | .                              */
             /* Exemple:                                                   */
             /* strcpy(sztt_txt,"Premiere ligne|deuxieme ligne|troisieme");*/
             /* Si vous placez une chaine vide "", la bulle d'aide ne sera */
             /* pas affichee.                                              */
             /*  Exemple: strcpy(sztt_txt,"");                             */
              
             { /*char *sztt_txt = (char*)     *(long*)(&Evnt->pipe[W_G]); */
              
             }
             break;  
        case WM_REDRAW: Lister_rectangles(w_h,(GRECT*)&Evnt->pipe[X_G]);    break;
        case WM_BOTTOM: wind_set(w_h, WF_BOTTOM ,0,0,0,0);                          break;
        case WM_TOPPED: wind_set(w_h, WF_TOP ,0,0,0,0);                             break;
        case WM_CLOSED: SendWindMessage(w_h, WM_MODAL_END, 0);              break;
        case WM_MODAL_END: DestroyWindow(w_h);                              break;
        case WM_ALLICONIFY: AllIconify((GRECT*)& Evnt->pipe[X_G]);          break;
        case WM_ICONIFY:    IconifyWindow(w_ind,(GRECT*)& Evnt->pipe[X_G]); break;
        case WM_UNICONIFY:  UnconifyWindow(w_ind);                          break;
        case WM_SIZED:
             {GRECT wgrect, old_wgrect,deltgrect;
              INT16 deltx,delty;
              CloseListBox (w_ind);

              GetGemWindExtGRECT(w_h, &wgrect);
              WindGemBorderToEZWork(Windtab[w_ind].w_attr, &wgrect, &old_wgrect);
              WindGemBorderToEZWork(Windtab[w_ind].w_attr,(GRECT*)& Evnt->pipe[X_G], &wgrect);

              deltx = wgrect.g_w -  old_wgrect.g_w;
              delty = wgrect.g_h -  old_wgrect.g_h;
              object[LISTBOX_VERT_BAR].ob_x           += deltx;
              object[LISTBOX_VERT_UP].ob_x            += deltx;
              object[LISTBOX_VERT_DWN].ob_x           += deltx;
              object[LISTBOX_TXTED].ob_width          += deltx;
              object[LISTBOX_VERT_DWN].ob_y           += delty;
              object[LISTBOX_VERT_BAR].ob_height      += delty;
              object[LISTBOX_TXTED].ob_height         += delty;
              
              object[LISTBOX_HORZ_BAR].ob_y           += delty;
              object[LISTBOX_HORZ_LFT].ob_y           += delty;
              object[LISTBOX_HORZ_RGT].ob_y           += delty;
              object[LISTBOX_HORZ_RGT].ob_x           += deltx;
              object[LISTBOX_HORZ_BAR].ob_width       += deltx;
              
              SetScrollBoxParam(object,LISTBOX_TXTED,-2,-2,-2,-2,-2,-2,-2,-2,(void*)-2L,LST_NODRAW);
              OnWm_sized(w_ind, Evnt);
              SetScrollBoxParam(object,LISTBOX_TXTED,-2,-2,-2,-2,-2,-2,-2,-2,(void*)-2L,LST_DRAW);
              SendObjectRedraw(w_h, object, LISTBOX_TXTED);

              /*................ ajuster les ascenseurs ...........*/
              AdjustWINDLISTSlide(object);
              SendObjectRedraw(w_h, object, LISTBOX_HORZ_BAR);
              SendObjectRedraw(w_h, object, LISTBOX_VERT_BAR);
              /*................. TRACER LES RELIQUATS ............*/
              objc_offset(object,LISTBOX_TXTED,&deltx,&delty);
              if (wgrect.g_w<old_wgrect.g_w)
                 {deltgrect.g_x = deltx + object[LISTBOX_TXTED].ob_width;
                  deltgrect.g_y = wgrect.g_y;
                  deltgrect.g_w = wgrect.g_x + wgrect.g_w - deltgrect.g_x;
                  deltgrect.g_h = wgrect.g_h;
                  SendGrectRedrawMessage( w_h, &deltgrect);
                  ExeAllMessage();
                 }
                 
              if (wgrect.g_h<old_wgrect.g_h)
                 {deltgrect.g_x = wgrect.g_x;
                  deltgrect.g_y = delty + object[LISTBOX_TXTED].ob_height;
                  deltgrect.g_w = wgrect.g_w;
                  deltgrect.g_h = wgrect.g_y + wgrect.g_h - deltgrect.g_y;
                  SendGrectRedrawMessage( w_h, &deltgrect);
                  ExeAllMessage();
                 }
              /*........... mettre  jour le rectangle edition texte ........*/
              UpdateWINDLISTTexte( object, LISTBOX_TXTED, EZ_ED_GetTxtEditStruct(object, LISTBOX_TXTED));
             }break;
             
        case WM_MOVED:  OnWm_moved(w_ind, Evnt);      break;
        case WM_FULLED: OnWm_fulled( w_ind, Evnt);    break;
             
       } /* end switch message     */
    } /* end if Evnt & MU_MESSAG  */      
 return Evnt->evnt;    /* retourner le flux evenementiel (modifie ou pas)    */
}
/*------------------------ GetWindDeltaY --------------------------------*/
INT16  GetWindDeltaY(INT16 kind)
{INT16 h, dumy;
 wind_calc( 0, kind,
            0, 0, 100, 100,
            &dumy, &dumy, &dumy, &h );
 return h-100;

}
/*------------------------ AdjustWINDLISTSlide -------------------------*/
void AdjustWINDLISTSlide(OBJECT *object)
{GRECT grect;
 INT16 lgnh, clnw, nbl_view, nbc_view;
 long nb_lgn, nb_cln, fstc, fstl, posh, posv;
              
 GetScrollBoxGRECT( object, LISTBOX_TXTED, &grect, -1);
 GetScrollBoxLParam(object, LISTBOX_TXTED, &lgnh, &clnw, &nb_lgn, &nb_cln, &fstl, &fstc, 0, 0, 0, 0);
 nbl_view = grect.g_h / lgnh;
 nbc_view = grect.g_w / clnw;
 SetSlideWidth(object, LISTBOX_HORZ_BAR,  nb_cln, nbc_view, fstc, MIN_SLIDE_W, HORIZONTAL); 
 SetSlideWidth(object, LISTBOX_VERT_BAR,  nb_lgn, nbl_view, fstl, MIN_SLIDE_W, VERTICAL);   
 posh = Min(fstc, nb_cln - nbc_view);
 posv = Min(fstl, nb_lgn - nbl_view);
 DocPosToSlidePos(object,  LISTBOX_HORZ_BAR, nb_cln, nbc_view, posh, HORIZONTAL);
 DocPosToSlidePos(object,  LISTBOX_VERT_BAR, nb_lgn, nbl_view, posv, VERTICAL);
 SetScrollBoxParam(object, LISTBOX_TXTED,-2,-2,-2,-2, posv, posh, -2,-2,(void*)-2L,-2);
}

/*------------------------ AdjustRscToWind ------------------------------*/
void AdjustRscToNewGrectWind(long w_attr, OBJECT *object, GRECT *oldGrect,  GRECT *newGrect)
{GRECT old_wgrect,new_wgrect;
 INT16 deltx,delty;

 WindGemBorderToEZWork(w_attr, oldGrect, &old_wgrect);
 WindGemBorderToEZWork(w_attr, newGrect, &new_wgrect);

 deltx = new_wgrect.g_w -  old_wgrect.g_w; 
 delty = new_wgrect.g_h -  old_wgrect.g_h;    
 object[LISTBOX_VERT_BAR].ob_x           += deltx;
 object[LISTBOX_VERT_UP].ob_x            += deltx;
 object[LISTBOX_VERT_DWN].ob_x           += deltx;
 object[LISTBOX_TXTED].ob_width          += deltx;
 object[LISTBOX_VERT_DWN].ob_y           += delty;
 object[LISTBOX_VERT_BAR].ob_height      += delty;
 object[LISTBOX_TXTED].ob_height         += delty;
 
 object[LISTBOX_HORZ_BAR].ob_y           += delty;
 object[LISTBOX_HORZ_LFT].ob_y           += delty;
 object[LISTBOX_HORZ_RGT].ob_y           += delty;
 object[LISTBOX_HORZ_RGT].ob_x           += deltx;
 object[LISTBOX_HORZ_BAR].ob_width       += deltx;
}
/*------------------------ UpdateWINDLISTTexte -----------------------------*/
void UpdateWINDLISTTexte( OBJECT *object, INT16 ob_ind, TXTED_OB *TXT_A)
{INT16 nbr_l, prm_l;
 /*.................. mettre  jour le rectangle edition texte ..........*/
 GetScrollBoxParam       (object,                     /* adresse de l'arbre dans lequel est l'objet      */
                          ob_ind,                     /* indice de l'objet dans l'arbre                  */
                          &TXT_A->IntLg,              /* hauteur en pixels d'une ligne de scrolling      */
                          0,                          /* largeur en pixels d'une colonne scrolling       */
                          0,                          /* Nombre total de lignes document                 */
                          0,                          /* nombre total de colonnes document               */
                          &prm_l,                     /* indice ligne document  afficher en 1er         */
                          0,                          /* indice colonne document  afficher  gauche     */
                          0,                          /* ligne selectionne ( mettre en surbrillance)   */
                          0,                          /* colonne selectionne ( mettre en surbrillance) */
                          0,                          /* paramtre optionnel  type de pointeur          */
                          &nbr_l                      /* nbr de cases afichables                         */
                         );
 /*.......... updater les parametres de ligne de l'editeur ..............*/
 TXT_A->PremLigVisible = prm_l;
 TXT_A->NbreLigVisible = nbr_l;
 /*........... updater le rectangle texte de l'editeur ..................*/
 GetScrollBoxGRECT(object, ob_ind, &TXT_A->TxtGrect, -1);
 /*............. appeler fonction d'update de l'editeur de texte ........*/
 TXT_A->EditTxtPosChg(TXT_A);
}

/*----------------------------- OnMouseList ------------------------------*/
INT16 OnMouseList(INT16 w_ind, TXTED_OB  *TXT_A, long x, long y)
{char *pt;
 if (!IsMouseXYInGrect((INT16)x, (INT16)y, &TXT_A->TxtGrect)) return -1;
 
 SendWindMessage(GETGEMHAND(w_ind), WM_MODAL_END, 0);
 pt  = EZ_ED_GetLigCol(XY_TO_LIGPT, &y, &x, TXT_A);
 PLSTB_IO->pt       = PLSTB_IO->txt + (pt - TXT_A->ptTxt);
 PLSTB_IO->ret      = y;
 while (*pt && *pt ==' ') pt++;
 if (*pt==0||*pt=='\r')
    {PLSTB_IO->pt       = 0;
     PLSTB_IO->ret      = -1;
    }
 return (INT16)PLSTB_IO->ret;
}