/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\   COMMPLUS.C    \\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/* Ce module est le source C du programme: PCSTUDIO.PRG                */
/* Le fichier projet associ est:          PCSTUDIO.PRJ                */
/* Gestion de la fenetre des commandes                                 */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ I N C L U D E S \\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*-------------------- INCLUDES DES AUTRES MODULES DU PROGRAMME -------*/
#include <EAZY_GEM.H>

/*--------------------- INCLURE LES DEFINITIONS SYMBOLIQUES ------------*/
/*                      que l'diteur de ressource gnre               */
/*                      lors de la cration de la ressource             */
#include "PCSTUDIO.SYS\COMMPLUS.H"
#include "PCSTUDIO.SYS\P2IMESSG.H"
#include "PCSTUDIO.SYS\SHORTCUT.H"

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ D E F I N E S  \\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                         TYPAGE DES FENETRES                          */
/*----------------------------------------------------------------------*/
#define W_PCSTUDIO    1     /* (identificateur ou type) de la Fenetre   */
#define W_CONFIG      2     /* (identificateur ou type) de la Fenetre   */
#define W_PEXEC3      3     /* (identificateur ou type) de la Fenetre   */
#define W_WINDLIST    4     /* (identificateur ou type) de la Fenetre   */
#define W_ABOUT       5     /* (identificateur ou type) de la Fenetre   */
#define W_COMMPLUS    6     /* (identificateur ou type) de la Fenetre   */

#define MAX_PATH 256

typedef struct
 {char *txt;
  char *pt;
  long ret;
 } LISTBOX_IN_OUT;
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\ V A R I A B L E S    G L O B A L E S \\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/* il n' y en a pas pour cet exemple !!                                 */
extern EVNT_I Default_evnt_i;
extern char **TxtPtStrMess;  /* pointera sur tableau de messages   */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\ P R O T O T Y P E S  F O N C T I O N S \\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
void ActiveCOMMPLUS(void);
void ActiveCOMMPLUS_wind(INT16 ident, long attr, char *title, CALLBACK (*w_proc)(INT16 w_ind, EVNT_O *Evnt));
CALLBACK WindProcCOMMPLUS(INT16 w_ind, EVNT_O *Evnt);

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                A   C O M M E N C E   I C I   !!!!                   */
/*              Definition des fonctions de ce module                   */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*------------------------------ WindProcCOMMPLUS ---------------------------*/
/* Affiche la boite d'information du programme                           */
CALLBACK WindProcCOMMPLUS(INT16 w_ind, EVNT_O *Evnt)
{OBJECT *object   = GETWINDTREE(w_ind); 
 INT16 wh_top     = GetTopWind();
 INT16 w_h        = GETGEMHAND(w_ind);  /* celui GEM de notre fenetre     */
 /*............................Rpondre  l'vnement MU_KEYBD .........*/
 if (Evnt->evnt & MU_KEYBD && w_h == wh_top)
    {Xform_keybd(w_ind, Evnt);
    }
    
 if (Evnt->evnt & MU_BUTTON )
    {INT16 ob_ret = Xform_button(w_ind, Evnt);
     /* if (ob_ret == INFO_SCROLL) */
        {Evnt->evnt &= ~MU_BUTTON;   /* empecher propagation message  MU_BUTTON */
         /*............. si objet exit selectionne ...................*/
         object[ob_ret&0x7FFF].ob_state &= ~SELECTED;
         SendWindMessage(w_h, WM_CLOSED, 0L);
        }
    } /* endif MU_BUTTON  et fenetre au premier plan */

 if (Evnt->evnt & MU_TIMER && w_h==wh_top)  Xform_timer(w_ind, Evnt);    
 if (Evnt->evnt & MU_MOVE)                  Xform_mu_move(w_ind, Evnt);     
 if (Evnt->evnt & MU_MESAG)
    {switch (Evnt->pipe[MESG])
       {case WM_CONSTRUCT:
             if (WindDialogConstruct(w_ind, 
                                     LoadAppliRsc( "COMMPLUS.RSC", NO_SCALE), 0, RSC_DIAL, Evnt
                                    ) == WM_ABORT
                ) return WM_ABORT;     
             AdjustWindCoordToScreen (w_ind, Evnt, (GRECT*)&Evnt->pipe[X_B]); 
             break;
                                          
        case WM_DESTRUCT:         Xform_Destruct(w_ind, Evnt);    
                                  RscFicUnLoad(Windtab[w_ind].DlgVar.AdrRsc);         break;
        case WM_TT_ON_OFF:        SetBulleState(w_h, object);                         break;
        case WM_REDRAW:           Lister_rectangles(w_h,(GRECT*)&Evnt->pipe[X_G]);    break;
        case WM_BOTTOM:           wind_set(w_h, WF_BOTTOM ,0,0,0,0);                          break;
        case WM_TOPPED:           wind_set(w_h, WF_TOP ,0,0,0,0);                             break;
        case WM_CLOSED:           DestroyWindow(w_h);                                 break;
        case WM_ALLICONIFY:       AllIconify((GRECT*)& Evnt->pipe[X_G]);              break;
        case WM_ICONIFY:          IconifyWindow(w_ind, (GRECT*)& Evnt->pipe[X_G]);    break;
        case WM_UNICONIFY:        UnconifyWindow(w_ind);                              break;
        case WM_SIZED:
        case WM_MOVED:            Xform_moved(w_ind, Evnt);                           break;
       }
    }      
 return Evnt->evnt;    /* retourner le flux evenementiel (modifie ou pas)    */
}

/*-------------------------- ActiveWindow ----------------------------------*/
void ActiveCOMMPLUS(void)
{ActiveCOMMPLUS_wind(W_COMMPLUS, XMOVER|XBORDER, "A propos", WindProcCOMMPLUS);
}
/*-------------------------- ActiveWindow ----------------------------------*/
void ActiveCOMMPLUS_wind(INT16 ident, long attr, char *title, CALLBACK (*w_proc)(INT16 w_ind, EVNT_O *Evnt))
{INT16 w_ind;
 w_ind = IsWindExist(ident);
 if (w_ind==-1)                 /* << SI existe pas la creer         */
    { INT16 w_h = CreateWindow(0x8000|attr, ident,0L,w_proc, 0,20+((Ecran_h-20)>>1),Ecran_l,(Ecran_h-20)>>1, title);
      if (w_h==-3||w_h==-2) form_alert(1,"Plus de fenetres ");
    }
 else                           /* << SI elle existe                  */
    {if (Windtab[w_ind].w_flag & W_IS_ICON || 
         Windtab[w_ind].w_flag & W_IS_ALLICON
        )
        {UnconifyWindow(w_ind); 
        }
     else if (IsWindOpen(w_ind))     /*        SI ouverte la mettre au top */
        {wind_set(Windtab[w_ind].w_h,WF_TOP,0,0,0,0);
        }
     else                       /*        SI pas ouverte l'ouvrir     */
        {OpenWindow(w_ind, &Windtab[w_ind].ExtGrectUse);
        } 
    } 
}