/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\ EZ_TXT.C \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\ SOURCE   du module de GESTION \\\\\\\\\\\\\\\\\\\*/
/*                    d'une fenetre de lancemement de process avec     */
/*                    reception des messages  STDOUT                   */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
#include <EAZY_GEM.H>
#include "PCSTUDIO.SYS\PEXEC3.H" 
#include "PCSTUDIO.SYS\SHORTCUT.H"
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ D E F I N E S  \\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
typedef struct
 {
  char *newcmd;       /* -> program pathname             */
  long ramlimit;      /* maximum memory size for process */
  long priority;      /* child process priority level    */
  char *defdir;       /* -> default directory pathname   */
  char *env;          /* -> environment string           */
 } SHELW;

typedef CALLBACK (*WIND_FUNC)(INT16 w_ind, EVNT_O *Evnt);
#define W_PCSTUDIO    1     /* (identificateur ou type) de la Fenetre   */
#define W_CONFIG      2     /* (identificateur ou type) de la Fenetre   */
#define W_PEXEC3      3     /* (identificateur ou type) de la Fenetre   */
#define W_WINDLIST    4     /* (identificateur ou type) de la Fenetre   */
#define W_ABOUT       5     /* (identificateur ou type) de la Fenetre   */
#define W_COMMPLUS    6     /* (identificateur ou type) de la Fenetre   */

#define WM_UPDATE_CFG (WM_USER+123)
#define W_PEXEC3  3
#define MAX_PATH 256
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\ V A R I A B L E S    G L O B A L E S \\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
extern char  PathAppli[MAX_PATH];
extern char  CmdTrace;
extern void *Gsc;
extern char  PathProject[MAX_PATH];
extern GRECT STDOUT_Grect;
extern CALLBACK DefautCallbackProc(INT16 w_ind, EVNT_O *Evnt);
extern char IsStdoLink;
extern int  Dwx;
extern int  Dwy;
/* extern INT16 STD_OUT; */
/* extern WIND_FUNC MEN_proc; */
/*\\\\\\\\\\\\\\ V A R I A B L E S  I N T E R N E S \\\\\\\\\\\\\\\\\\\*/
char  *MemFile    = 0;
long   PtMemFile  = 0;
long   LenMemFile = 0;
long   HFconout;
long   HFexconout;
long   HFexaux;
char **EnvList;
INT16  VarSysInfo;
INT16  TosWinFlag     = 0;
long   TimeOutProcess = 2400;  /* 240 secondes = 4 minutes */
char   WindMessLock   = 0;
/*\\\\\\\\\\\\\\\\\ P R O T O T Y P E S  E X T E R N E S \\\\\\\\\\\\\\\\*/
extern INT16  Event_dispatch(EVNT_O* Evnt_o, WIND_FUNC default_proc);
extern char  *PathToProcessName(char *path_process, char *proces_name);
extern INT16  ExeEditeur(char *nom_txt, INT16 mode);
extern INT16  WaitForEndProcess(char *path_process, long timeout);
extern INT16    ExeFunction(INT16 com);
/*\\\\\\\\\\\\\\\\\ P R O T O T Y P E S  I N T E R N E S \\\\\\\\\\\\\\\\*/
void    *CreateMemFile(long len_mem);
void     DestroyMemFile(void);
char    *GetMemFile(long *ptlen);
void     OpenMemFile(void);
long     WriteMemFile(void *src, long len);


CALLBACK WindProcPEXEC3(INT16 w_ind, EVNT_O *Evnt);
void     detourne_console(void);
void     console_normale(void);
long     XPexec(INT16 mode, char *path, char *tail, char *env);
void     AdjustSrollInfoSlide(OBJECT *object);
void     UpdateParamTexte( OBJECT *object, INT16 ob_ind, TXTED_OB *TXT_A);
void     my_Dsetpath(char *path);
void     donne_chemin(char *path, char *buf);
char    *get_directory(char *path);
INT16    wprintf( const char *format, ... );
void     AddString(INT16 w_ind, char *txtref, TXTED_OB  *TXT_A);
void     CloseSTD_OUT(void);
void     OpenSTD_OUT(INT16 mode, GRECT *ext_grect);
long     my_Pvfork(void);
void     WReadFile(long fp);
void     LockWindMessage(void);
void     UnLockWindMessage(void);
char    *GoFirstValid(char *pt, char *tojump);
INT16    OnMouseErreur(TXTED_OB  *TXT_A, long x, long y);
void     AdjustSTD_OUTToNewGrectWind(INT16 w_attr, OBJECT *object, GRECT *oldGrect, GRECT *newGrect);
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                A   C O M M E N C E   I C I   !!!!                    */
/*              Definition des fonctions de ce module                    */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*-------------------------- detourne_console --------------------------*/
void detourne_console(void)
{char path[MAX_PATH];
 strcpy(path, PathAppli);
 strcat(path, "_conout.txt");
 HFconout=Fcreate(path,0);
 /*........ si echec on retente .......*/
 if (HFconout<0L)
    {
 #ifdef __GEM_LIB__
     evnt_timer(200L);
 #else
     evnt_timer(200,0);
 #endif
     HFconout=Fcreate(path, 0);
    }
 if (HFconout>=0L)
    {HFexconout = Fdup(1);
     HFexaux    = Fdup(2);
     Fforce(1,(INT16)HFconout);
     Fforce(2,(INT16)HFconout);
     Fclose((INT16)HFconout);   /* rajoute ## */
    }
}

/*-------------------------- console_normale ---------------------------*/
void console_normale(void)
{if (HFconout>=0L)
    {Fforce(1, (INT16)HFexconout);
     Fclose((INT16)HFexconout);
     Fforce(2, (INT16)HFexaux);
     Fclose((INT16)HFexaux);
     HFconout=NULL;
    }
}
/*----------------------------------- XPexec ----------------------------*/
/* Grandement Merci  Olivier Landemarre qui m'a donn son source grace  */
/* auquel cette fonction a pu etre realise.                             */

long XPexec(INT16 mode, char *path, char *tail, char *env) 
/* char *path,*tail,*env;
   INT16 mode;               mode + 10000 on garde le rpertoire courant */
{char   environ[1500];
 char **pt_env;
 long   inf          = 0L;
 short  flag_console = 0;
 char  *first_env    = env;
 char   proc_name[MAX_PATH];
 if (tail==0) tail="";
 /*(void)universal_path(path);*/
 /*............ recuperer le nom du process  lancer ...................*/
 PathToProcessName(path, proc_name);

 /*............ si pas d'environnement prendre celui par defaut ........*/
 if (env==NULL) 
    {char *fin;
     short     i= 0; 
     environ[0] = 0;
     pt_env     = EnvList;
     fin        = environ;
     while(pt_env[i]!=NULL)
        {strcat(fin,pt_env[i]);
         while(*fin) fin++;
         fin++;
         *fin=0;
         i++;
        }
     env=environ;
    }
 /*................ allez on y va .......................................*/
 if (path!=NULL) 
    {char buf[MAX_PATH];
     char chemin[MAX_PATH];
     char new_chemin[MAX_PATH];
     char envp[1500];
     char buffer[256];
     
     get_directory(chemin);
     strcpy(&buf[1], chemin);
     
     buf[1]=0;
     donne_chemin(path, &buf[1]);
     
     if (buf[1])
        {my_Dsetpath(&buf[1]);
         strcpy(new_chemin, &buf[1]); 
        }
     if ((mode<20000)&&(mode>=10000) ||mode==3000)  /* on veut rester dans le rpertoire courant */
        {if (mode!=3000) mode -= 10000;
         my_Dsetpath(chemin);
         strcpy(new_chemin, chemin);
        }
     /*.............. si passage d'arguments par ligne de commande ................*/
     /*              execede 125, initialiser la chaine d'environnement            */
     /*             avec ARGV= et placer argument dedans                           */
     if (tail!=NULL)
        {/*......... couper la commande au max possible .................*/
         unsigned short taille = (unsigned short)strlen(tail);
         if (taille>125)             /* spcification  passage arguments long */
            {sprintf(buffer,"%c%125s",127,tail); buffer[126]=0;
            }
         else
            {sprintf(buffer, "%c%s", (char)taille, tail); /*Pour regler un probleme avec PEXEC (il faut mettre la taille de Tail)*/ 
            }
         
         /*............ si chaine ARGV toute prete l'utiliser............*/
         /*             telle quelle: env pointe deja dessus             */
         if (mode==3000)
            {mode = 0;
            }
         /*............. sinon en creer une  partir de tail ............*/
         else
            {char *pt_env,*pt_envp;
             
             pt_env  = env;
             pt_envp = envp;
             while (*pt_env)
               {while (*pt_env)
                  {*pt_envp++=*pt_env++;
                  }
                *pt_envp++=*pt_env++;
               }
             if (taille>1350) 
                {sprintf(pt_envp,"ARGV=%c%s%c%1350s%c%c",0,path,0,tail,0,0);
                 form_alert(1,"[1][commande trop longue (>1350)|elle sera coupe][Ok]");
                }
             else 
                {sprintf(pt_envp,"ARGV=%c%s%c%s%c%c",0,path,0,tail,0,0);
                }
             while(*pt_envp++); /* passer ARGV=                        */
             while(*pt_envp++); /* passer path                         */
             while(*pt_envp++)  /* separer les arguments par des zeros */
               {if ((*pt_envp==' ')&&(pt_envp[1]!=' ')) 
                   {*pt_envp++=0;
                   }
               }
             env = envp;
            }
         
         /*.......................... Multitache ..............................*/
         /*               lancement en paralele selon Magic ou Mint            */
         /*         on rentre obligatoirement dans cette boucle si le systeme  */
         /*         est multitache car je n'mule pas les autres modes         */
         /*                                                                    */
         if ((mode==100 && VarSysInfo&1)||
             (mode==0   && VarSysInfo&1)
            ) 
            {SHELW sh;
             char *pt_path = GetExtension(path, 0);
             long pid_fils = -1L;  /* ## */
             sh.newcmd     = (char *)path;
             sh.env        = (char *)env;
             sh.defdir     = new_chemin;
             
             if (pt_path                   && 
                 ((!strcmp(pt_path,".TTP"))||
                  (!strcmp(pt_path,".ttp"))||
                  (!strcmp(pt_path,".TOS"))||
                  (!strcmp(pt_path,".tos"))
                 )
                )
                {/* redirection selon TOS2WIN j'essaye ! */
                 /*long i         = my_Pvfork();   */      /*,thread, kidfd*//* i = Pvfork();  */
                 long  i         = Pfork();
                 /*long  i         = Pvfork();*/
                 /* long  i = PVFORK(); */
                 if (i < 0)                 /* fork erreur */
                    {if  (CmdTrace)
                         {char *pt = env;
                          INT16    u = 0;
                          wprintf("Pexec de: %s No Pfork()= %d\r\n", sh.newcmd, i);
                          wprintf("  Commande Taille        : %d\r\n",(INT16)*buffer);
                          wprintf("  Commande Chaine        : %s\r\n", buffer+1);
                          wprintf("  Repertoire par defaut  : %s\r\n", sh.defdir);
                          while(pt[1] != 0)
                            {wprintf("  Environnememt Chaine N: %d : %s\r\n",u, pt);
                             pt += strlen(pt)+1;
                             u++;
                            }
                         }
                     if (TosWinFlag&1)
                        {inf=shel_write(1|0x800|0x400,0,100,(char *)&sh, buffer); /* lancement du programme en multitche */
                         /* 2eme param=0 TOS2WIN */
                        }
                     else
                        {if (appl_find(proc_name) != -1)
                            {char *txt = "[0][Process:                  |deja lanc !!|veuillez attendre...][OK]";
                             memcpy(txt+13, proc_name,8);
                             form_alert(1000, txt);
                             ExeAllMessage();
                             ExeAllMessage();
                             ExeAllMessage();
                             ExeAllMessage();
                             WaitForEndProcess(path, 3000);
                             WindAlertClose();
                             ExeAllMessage();
                             ExeAllMessage();
                             ExeAllMessage();
                             ExeAllMessage();
                            }
                         detourne_console();
                         /*           0x400 = set default directory  */
                         /*           0x800 = set environment string */
                         inf          = shel_write(1|0x800|0x400,1, 100, (char *)&sh, buffer);
                         console_normale();
                         flag_console = 3;
                        }
                    }
                 else if (i == 0)     /* processus fils ca marche!*/
                    {INT16 rep_Pexec;
                     
                     detourne_console();
                     rep_Pexec = (INT16)Pexec(200, path, buffer, env);
                     wprintf("\r\n  Pexec failed (err = %d)!\r\n", i);
                     wprintf("Press Shift Key for continue\r\n");
                     while(Kbshift(-1)==0);
                     exit(rep_Pexec);
                    }
                 else  /* dans processus pre Pvfork ok */
                    {long app     = 0xFFFF0000L+i;
                     pid_fils     = i;
                     inf          = appl_find((char *)app); /* recherche numro AES avec id Mint tordu!*/
                     flag_console = 3;
                     console_normale();
                     
                     if  (CmdTrace)
                         {char *pt = env;
                          INT16    u = 0;
                          wprintf("Pexec de: %s Pfork()     = %d\r\n", sh.newcmd,i);
                          wprintf("  AES  Process fils = %d\r\n", inf);
                          wprintf("  MinT Process fils = %d\r\n", pid_fils);
                          wprintf("  Commande Taille        : %d\r\n",(INT16)*buffer);
                          wprintf("  Commande Chaine        : %s\r\n", buffer+1);
                          wprintf("  Repertoire par defaut  : %s\r\n", sh.defdir);
                          while(pt[1] != 0)
                            {wprintf("  Environnememt Chaine N: %d : %s\r\n",u, pt);
                             pt += strlen(pt)+1;
                             u++;
                            }
                         }
                    }
                } /* endif if ((!strcmp(pt_path,"TTP"))||(!strcmp(pt_path,"ttp") */
             else 
                {inf=shel_write(1|0x800|0x400,1,100,(char *)&sh/*path*/,buffer/*tail*/); /* lancement du programme en multitche */
                 console_normale();
                 flag_console = 3;
                 /*    2eme param=1 sans TOS2WIN */
                }
             if (mode==0) /* dans un systeme multitache on veut envoyer un programme dont on attend la fin */
                {INT16  run        = 1;
                 long   fp         = NULL;
                 EVNT_O evnt_o;
                 char   nom[MAX_PATH];
                 INT16 process_ID  = -2;
                 INT16 evnt_flag   = 0;
                 /*............ ouvrir fichier de sortie .................*/
                 OpenMemFile();       /* reinitialiser le fichier memoire */
                 strcpy(nom, PathAppli);
                 strcat(nom, "_conout.txt");
                 LockWindMessage();
                 evnt_flag   = MU_TIMER|MU_MESAG|MU_MOVE|MU_BUTTON;
                 while (run)
                  {evnt_o.evnt = 
             #ifdef __GEM_LIB__
                 /*.............. avec __GEM_LIB__ .......................*/
                 /*             on reoit CH_EXIT                         */
                       evnt_multi(evnt_flag, 0x102,3,0,0,0,0,0,0,0,0,0,0,0,
                                  evnt_o.pipe,
                                  250,
                                  &evnt_o.x,   &evnt_o.y,   &evnt_o.k,
                                  &evnt_o.ksp, &evnt_o.key, &evnt_o.click
                                 );
             #else
                 /*.............. sans __GEM_LIB__ .......................*/
                 /*             on reoit pas CH_EXIT                     */
                 /*             donc sortie avec TIMER                    */
                       evnt_multi(evnt_flag, 0x102,3,0,0,0,0,0,0,0,0,0,0,0,
                                  evnt_o.pipe,
                                  LOWORD(250), HIWORD(250),
                                  &evnt_o.x,   &evnt_o.y,   &evnt_o.k,
                                  &evnt_o.ksp, &evnt_o.key, &evnt_o.click
                                 );
             #endif 
                   if (evnt_o.evnt&MU_MESAG)
                      {/*...... soit message fin process .......*/
                       /*       alors sortir                    */
                       if (evnt_o.pipe[MESG]==CH_EXIT)
                          {if  (CmdTrace) wprintf("  Reception du message: CH_EXIT: process_ID=%d inf=%d  pipe[3]=%d\r\n",process_ID, inf, evnt_o.pipe[3]);
                           if (evnt_o.pipe[3]==process_ID) break;
                          }
                       /*...... soit message normal ............*/
                       /*       alors l'executer                */
                       else 
                          {Event_dispatch(&evnt_o, (WIND_FUNC)DefautCallbackProc);
                          }
                      } /*endif (evnt_multi(MU_MESAG|...*/
                   /*...... si Mint ou Magic 6.1 ............*/
                   /*       attendre sortie process fils     */
                   /* les seuls  faire Pfork() == 0 d'ou    */
                   /* pid_fils>0L                            */
                   if (pid_fils>0L)
                      {long rusage[2];
                       if (Pwaitpid(pid_fils,1,rusage)<0L) /* Ca c'est pour Mint -NAES mais cela marche aussi sous Magic>=6 seul moyen de savoir si le process a termin */
                          {run=0; /* on simule la sortie du programme fils */
                           if  (CmdTrace) wprintf("  Sortie par: Pwaitpid()\r\n");
                          }
                      }
                   else
                      {process_ID = appl_find(proc_name); 
                       if (process_ID == -1) 
                          {run = 0;
                           if  (CmdTrace) wprintf("  Sortie par: appl_find()==-1\r\n");
                          }
                      }
                   if (Kbshift(-1)==K_LRSHIFT)
                      {wprintf("   Process interrompu par l'utilisateur\r\n\r\n",inf);
                       run = 0;
                      }
                   /*..... lecture (en  fichier memoire et ST_OUT) ....*/
                   /* MinT  n'aime pas la lecture en meme temps !!! */
                   if (MachineInfo.mult_os == 'MagX')
                      {if (flag_console && fp<=NULL)  fp = Fopen(nom, 0);
                       if (fp>=NULL) (void)Fcntl(fp, (long)0x100/*O_NDELAY*/, 0x0005/*F_SETFL*/);
                       WReadFile(fp);
                      }
                   
                  }/* endwhile (run) */
                 /*..... lecture (en  fichier memoire et ST_OUT) ....*/
                 if (flag_console && fp<=NULL) fp = Fopen(nom, 0);
                 if (fp>=NULL) (void)Fcntl(fp, (long)0x100/*O_NDELAY*/, 0x0005/*F_SETFL*/);
                 WReadFile(fp);
                 if  (CmdTrace) wprintf("   Sortie avec: %d\r\n\r\n",inf);
                 Fclose((INT16)fp);
                 fp=NULL;
                 UnLockWindMessage();
                } /* endif (mode==0) */
            } /*endif (((mode==100)&&(VarSysInfo&1) .... */
            
         /*.......................... Monotache ..............................*/
         /*                     lancement en monotache                        */
          else 
            {char *pt_path = GetExtension(path, 0);
             if (pt_path                 && 
                 ( (!strcmp(pt_path,".TTP"))||
                   (!strcmp(pt_path,".ttp"))||
                   (!strcmp(pt_path,".TOS"))||
                   (!strcmp(pt_path,".tos"))
                 )
                )
                {detourne_console();
                 flag_console=2;    
                }
             if (mode==100) 
                {if ((first_env==NULL)&&(taille<=125)) inf=Pexec(0,path,buffer,NULL);
                 else                                  inf=Pexec(0,path,buffer,env);
                }
             else 
                {if (mode==0 && VarSysInfo&1)
                    { /* on fait un Pexec monotache dans un systme multitache 
                         on dsactive le menu */
                      /*menu_inhib(0); */
                    } 
                 if ((first_env==NULL)&&(taille<=125)) inf=Pexec(mode,path,buffer,NULL);
                 else                                  inf=Pexec(mode,path,buffer,env); 
                 if ((mode==0)&&(VarSysInfo&1))
                    {/*menu_inhib(1);*/
                    }
                }
            }
        } /* if (tail!=NULL) */
     else 
        {inf=-1;
        }
     my_Dsetpath(chemin);
    } /* endif (path!=NULL)  */
  else 
    {UnLockWindMessage();
     return(-1L);
    }
  ExeAllMessage();
  
  /*......... c'est deja sorti ..................*/
  if (flag_console==2)
     {long fp=NULL; 
      console_normale();  
      strcpy(environ, PathAppli);
      strcat(environ, "_conout.txt");
      if (Fic_exist(environ, 0)>0)  
         {fp = Fopen(environ, 0);
          WReadFile(fp);
          wprintf("\r\n code retour programme =%ld\r\n",inf);
          if (fp>=0) Fclose((INT16)fp);
         }
     }
 UnLockWindMessage();
 return(inf);
}

/*------------------- CreateMemFile ------------------------------------------*/
void *CreateMemFile(long len_mem)
{LenMemFile = len_mem;
 MemFile    = malloc(len_mem+2);
 PtMemFile  = 0;
 return MemFile;
}

/*-------------------- DestroyMemFile --------------------------------------*/
void DestroyMemFile(void)
{if (MemFile) free(MemFile);
 MemFile    = 0;
 PtMemFile  = 0;
 LenMemFile = 0;
}

/*-------------------- GetMemFile --------------------------------------*/
char *GetMemFile(long *ptlen)
{if (ptlen)  *ptlen = PtMemFile;
 if (MemFile) MemFile[PtMemFile] = 0;
 return MemFile;
}

/*------------------------------ OpenMemFile -------------------------------*/
void OpenMemFile(void)
{PtMemFile = 0;
 if (MemFile) *MemFile = 0;
}

/*------------------------------ WriteMemFile -------------------------------*/
long WriteMemFile(void *src, long len)
{if (MemFile==0) return -1;
 if (PtMemFile + len < LenMemFile)
    {memcpy(MemFile + PtMemFile, src, len);
     PtMemFile += len;
     return len;
    }
 else
    {len = LenMemFile - PtMemFile;
     if (len) memcpy(MemFile + PtMemFile, src, len);
     PtMemFile = LenMemFile;
     return len;
    }
}

/*------------------------------ LockWindMessage ---------------------------*/
void LockWindMessage(void)
{WindMessLock |= 1;
}

/*------------------------------ UnLockWindMessage -------------------------*/
void UnLockWindMessage(void)
{/*
 if (WindMessLock & 2)
    {ApplWrite( Appl_id, WM_CLOSED);
    }
 */
 WindMessLock  = 0;
}

/*----------------------------- OnMouseErreur ------------------------------*/
INT16 OnMouseErreur(TXTED_OB  *TXT_A, long x, long y)
{char *txt      = 0;
 char *pt       = 0;
 char  path[MAX_PATH];
 char  nom[MAX_PATH>>1];
 char  argLig[32];
 INT16 editID;
 if (!IsMouseXYInGrect((INT16)x, (INT16)y, &TXT_A->TxtGrect)) return -1;
 if (TXT_A->State & MO_TRACK_ON)                              return -1;
 txt      = EZ_ED_GetLigCol(XY_TO_LIGPT, &y, &x, TXT_A);
 pt       = txt;
 while(*pt && *pt != '\r' && *pt !=' ') pt++;
 if (strncmpi(txt, "warning",7) == 0 ||
     strncmpi(txt, "error",5  ) == 0
    )
    {pt = GoFirstValid(pt," ");
     pt = Extrait_mot(path, pt, 0,", ");
     if (*pt==',') pt++;
     pt = GoFirstValid(pt," ");
     if (strncmp(pt, "line", 4)==0) pt +=5;
     pt = Extrait_mot(argLig, pt, 0, ": ");
     PathNomToNomFic(path, nom);
     if (*path==0) strcpy(path, PathProject);
     PathNomToNomFic(path, 0);
     editID = ExeEditeur(nom, 0);
     if (editID<=0) return 1;
     if ( Gsc == 0) Gsc = GSOpen( editID);
     if ( Gsc)
        {/*long numl = Max(0, argLig);*/
         strcat(path, nom);
         GSSendCommand( Gsc, "setCursorAt",3, path, "0", argLig);
         return 1;
        }
    }
 return -1;
}

/*------------------------------ WindProcPEXEC3 ----------------------------*/
CALLBACK WindProcPEXEC3(INT16 w_ind, EVNT_O *Evnt)
{OBJECT *object   = GETWINDTREE(w_ind); 
 INT16 wh_top     = GetTopWind();
 INT16 w_h        = GETGEMHAND(w_ind);  /* celui GEM de notre fenetre     */
 /*............................Rpondre  l'vnement MU_KEYBD .........*/
 if (Evnt->evnt & MU_KEYBD && Windtab[w_ind].w_h == wh_top)
    {Xform_keybd(w_ind, Evnt);
    }
    
 /*.......................... Rpondre  l'vnement MU_BUTTON .........*/ 
 
 if (Evnt->evnt & MU_BUTTON)
    {INT16     ob_ret = -1;
     TXTED_OB  *TXT_A = EZ_ED_GetTxtEditStruct(object, EZ_INFO_BOX);
     if ( OnMouseErreur(TXT_A,  Evnt->x, Evnt->y) == -1)
        {ob_ret = Xform_button(w_ind, Evnt); /* recuperer objet clique */
        }
     else Evnt->evnt &= ~MU_BUTTON;  
     if (ob_ret>-1)            /*<<<<SI UN OBJET EST CLIQUE >>>>>>>>>>>*/
        {/*.... empecher propagation message  MU_BUTTON ...............*/
         /*     de faon  ce qu'il ne soit pas possible de            */
         /*     cliquer sur deux fenetres  la fois.                   */
         Evnt->evnt &= ~MU_BUTTON;  
         
         /*.......le remettre en non selectionn et le redessiner......*/
         object[ob_ret].ob_state &= ~SELECTED;  
         if (object[ob_ret].ob_type &((G_CICON<<8)|G_USERDEF))
             SendObjectRedraw( w_h, object, ob_ret); 
         else
             Wobjc_draw(w_ind,object, ob_ret, 3, 0);
         
         /*.............. ICI ACTION SELON BOUTON CLIQUE..............*/
         /* j'ai mis en commentaire comment il est possible de tester */
         /* et lancer une action selon l'objet cliqu. Utilisez les   */
         /* symboles du fichier .H de la ressource (ici EZ_INFO.H) afin */
         /* de rendre votre programme plus lisible.                   */
                     
          switch (ob_ret)
            {
            }
        }  /* endif objet selectable cliqu  */ 
    } /* endif MU_BUTTON  et fenetre au premier plan */
 
 /*.......................... Rpondre  l'vnement MU_TIMER.............*/
 if (Evnt->evnt & MU_TIMER)  
    {if (w_h == wh_top ) Xform_timer(w_ind, Evnt);    
    }
   
 /*..........................Rpondre  l'vnement MU_MOVE ..............*/
 if (Evnt->evnt & MU_MOVE)   /*  (EZGEM evenement)   */
    {Xform_mu_move(w_ind, Evnt);
    }       
    
 /*..........................Rpondre aux messages MU_MESAG ..............*/
 if (Evnt->evnt & MU_MESAG)
    {switch (Evnt->pipe[MESG])
       {case WM_EDIT_UPDATE:
             /**************************************************************/
             /*................ WM_EDIT_UPDATE (EZ_GEM message)............*/
             /* Ce message est envoy a notre procedure de fenetre lorsque */
             /* un editeur de texte lui notifie un changement succeptible  */
             /* d'entrainer une mise a jour de la fenetre, ou lui notifie  */
             /* une action future pouvant etre modifiee.                   */
             /* en Evnt->pipe[X_G] se trouve la nature de la notification  */
             /* si egal a:                                                 */
            {TXTED_OB* TXT_A;
             EVNT_O *Evnt_txt; 
             switch(Evnt->pipe[X_G])
               {/*..... ED_CLICK_IN (il a ete clique dans le texte)...............*/
                /* en:    *(long*)&Evnt->pipe[W_G] adresse de l'editeur de texte  */
                /*        *(long*)&Evnt->pipe[X_B] variable de flux evenementiel  */
                /* Si il est retourne 0  ce message, l'editeur de texte ne       */
                /* ne recevra pas l'evenement.                                    */
                case ED_CLICK_IN:
                    {(long)TXT_A       = *(long*)&Evnt->pipe[W_G];
                     (long)Evnt_txt    = *(long*)&Evnt->pipe[X_B];
                     /*.................. BOUTON DROIT ...........................*/
                     if (Evnt->k == 2)  
                        {
                         return 0;
                        }
                     else
                        {OnMouseErreur(TXT_A, Evnt_txt->x, Evnt_txt->y);
                        }
                    } break;
                /*.......  ED_KEYB_DWN (une touche CLAVIER a ete appuyee)..........*/
                /* en:    *(long*)&Evnt->pipe[W_G] adresse de l'editeur de texte  */
                /*        *(long*)&Evnt->pipe[X_B] variable de flux evenementiel  */ 
                /* Si il est retourne 0  ce message, l'editeur de texte ne       */
                /* ne recevra pas l'evenement.                                    */
                case ED_KEYB_DWN:
                case ED_KEYB_CNTRL:
                case ED_KEYB_ALT:
                    {char scan;
                     /*(long)TXT_A       = *(long*)&Evnt->pipe[W_G]; */
                     (long)Evnt_txt    = *(long*)&Evnt->pipe[X_B];
                      scan        = (char)(Evnt_txt->key>>8);
                      
                      /*....... n'autoriser que CNTRL C et CTRL A .............*/
                      if (Evnt_txt->ksp   & K_CTRL
                         )
                         {char car  = (char)ScanToAscii(Evnt_txt->key, Evnt_txt->ksp);
                          if (strchr("aAcC",car)) return 1;
                          else                    return 0;
                         }
                      /*....... n'autoriser que les touches flechees ..........*/
                      switch(scan)
                         {case 0x1C:      /* ENTER                      */
                          case 0x72:      /* RETURN    Activer la ligne */
                               {
                               }
                               return 0;
                          case 75:
                          case 72:
                          case 80:
                          case 77:
                          case 71:
                            return 1;
                          default:
                            wprintf( "Fenetre STD_OUT en lecture seulement\r\n" );
                            return 0;
                         }/* end switch */
                        
                    } /* endcase ED_KEYB_ALT: */
               } /* endswitch(Evnt->pipe[X_G]) */
            } /* end case WM_EDIT_UPDATE: */
                     return 1;
        
        case WM_CONSTRUCT:
            {TXTED_OB  *TXT_A;
             GRECT *newGrect = (GRECT *)Windtab[w_ind].UserPtr;    /* rectangle exterieur  modifier */
             GRECT scrgrect;
             INT16 wind;
             /*......... charger et integrer la ressource .........*/
             if (WindDialogConstruct(w_ind, 
                                     LoadAppliRsc( "PEXEC3.RSC", NO_SCALE), 0, RSC_DIAL, Evnt
                                    ) == WM_ABORT
                ) return WM_ABORT;
             object   = GETWINDTREE(w_ind);
             TXT_A    = EZ_ED_GetTxtEditStruct(object, EZ_INFO_BOX);
             TXT_A->State   |=  EDIT_MOFORM_ARROW;
             if (newGrect && newGrect->g_w>10 && newGrect->g_h>10)
                {AdjustSTD_OUTToNewGrectWind(Windtab[w_ind].w_attr, 
                                             object, 
                                            (GRECT*)&Evnt->pipe[X_B], 
                                             newGrect);
                 *(GRECT*)&Evnt->pipe[X_B] = *newGrect;
                 /*............ faut pas depasser l'ecran ..............*/
                 wind_get(0,4,&scrgrect.g_x,&scrgrect.g_y,&scrgrect.g_w,&scrgrect.g_h); /*coordone ecran    GEM         */
                 AdjustGrectToGrect(&scrgrect, (GRECT*)&Evnt->pipe[X_B]);
                }
             else
                {AdjustWindCoordToScreen (w_ind, Evnt, (GRECT*)&Evnt->pipe[X_B]);
                }
             /*....... relever delta x ......*/
             wind  = IsWindExist(W_PCSTUDIO);
             if (wind  != -1)
                {GRECT  grect = Windtab[wind].ExtGrectUse;
                 Dwx = STDOUT_Grect.g_x - grect.g_x;
                 Dwy = STDOUT_Grect.g_y - grect.g_y;
                }
             UpdateParamTexte(object, EZ_INFO_BOX, TXT_A);
             VascHeightAdjust(object, EZ_INFO_BOX, EZ_INFO_VERT_BAR, EZ_INFO_VERT_ASC);
             break; 
            }
        case WM_DESTRUCT:       /*  (EZGEM message)   */
            {/*
             INT16 wind  = IsWindExist(W_PCSTUDIO);
             if (wind != -1) SendWindMessage(GETGEMHAND(wind), WM_UPDATE_CFG, 0);
             */
             Xform_Destruct(w_ind, Evnt);    
             RscFicUnLoad(Windtab[w_ind].DlgVar.AdrRsc);
             
            }
             break;
        case WM_TT_ON_OFF:      /*  (EZGEM message)   */
             SetBulleState(w_h, GETWINDTREE(w_ind));
             break;
        case WM_TT_GET_TXT:     /*  (EZGEM message)   */
             /**************************************************************/
             /*...................... WM_TT_GET_TXT .(EZGEM message).......*/
             /* Ce message est envoy a notre procedure de fenetre chaque  */
             /* fois que le systeme d'affichage d'une bulle d'aide desire  */
             /* qu'on lui fournisse un texte  afficher.                   */
             /* Ce texte peut etre affiche sur plusieurs lignes en mettant */
             /* comme separateur le signe | .                              */
             /* Exemple:                                                   */
             /* strcpy(sztt_txt,"Premiere ligne|deuxieme ligne|troisieme");*/
             /* Si vous placez une chaine vide "", la bulle d'aide ne sera */
             /* pas affichee.                                              */
             /*  Exemple: strcpy(sztt_txt,"");                             */
              
             { /*char *sztt_txt = (char*)     *(long*)(&Evnt->pipe[W_G]); */
              
             }
             break;  
        case WM_REDRAW: Lister_rectangles(w_h,(GRECT*)&Evnt->pipe[X_G]);    break;     
        case WM_BOTTOM: wind_set(w_h, WF_BOTTOM ,0,0,0,0);                          break;
        case WM_TOPPED: wind_set(w_h, WF_TOP ,0,0,0,0);                             break;
        case WM_CLOSED: 
             if (WindMessLock) WindMessLock |= 2;
             else              DestroyWindow(w_h);
             break;
        
        case WM_ALLICONIFY: AllIconify((GRECT*)& Evnt->pipe[X_G]);          break;
        case WM_ICONIFY:    IconifyWindow(w_ind,(GRECT*)& Evnt->pipe[X_G]); break;
        case WM_UNICONIFY:  UnconifyWindow(w_ind);                          break;
        case WM_SIZED:
             {GRECT wgrect, old_wgrect, new_extgrect, deltgrect;
              INT16 deltx,delty;
              CloseListBox (w_ind);
              new_extgrect = *(GRECT*)& Evnt->pipe[X_G];
              GetGemWindExtGRECT(w_h, &wgrect);
              WindGemBorderToEZWork(Windtab[w_ind].w_attr, &wgrect,       &old_wgrect);
              WindGemBorderToEZWork(Windtab[w_ind].w_attr, &new_extgrect, &wgrect);

              deltx = wgrect.g_w -  old_wgrect.g_w;
              delty = wgrect.g_h -  old_wgrect.g_h;
              object[EZ_INFO_VERT_BAR].ob_x           += deltx;
              object[EZ_INFO_VERT_UP].ob_x            += deltx;
              object[EZ_INFO_VERT_DW].ob_x            += deltx;
              /*object[EZ_INFO_BULLE_ON].ob_x           += deltx;*/
              object[EZ_INFO_BOX].ob_width            += deltx;
              object[EZ_INFO_VERT_DW].ob_y            += delty;
              object[EZ_INFO_VERT_BAR].ob_height      += delty;
              object[EZ_INFO_BOX].ob_height           += delty;
              
              object[EZ_INFO_HORZ_BAR].ob_y           += delty;
              object[EZ_INFO_HORZ_LFT].ob_y           += delty;
              object[EZ_INFO_HORZ_RGT].ob_y           += delty;
              object[EZ_INFO_HORZ_RGT].ob_x           += deltx;
              object[EZ_INFO_HORZ_BAR].ob_width       += deltx;
              
              SetScrollBoxParam(object,EZ_INFO_BOX,-2,-2,-2,-2,-2,-2,-2,-2,(void*)-2L,LST_NODRAW);
              OnWm_sized(w_ind, Evnt);
              SetScrollBoxParam(object,EZ_INFO_BOX,-2,-2,-2,-2,-2,-2,-2,-2,(void*)-2L,LST_DRAW);
              SendObjectRedraw(w_h, object, EZ_INFO_BOX);

              /*................ ajuster les ascenseurs ...........*/
              AdjustSrollInfoSlide(object);
              SendObjectRedraw(w_h, object, EZ_INFO_HORZ_BAR);
              SendObjectRedraw(w_h, object, EZ_INFO_VERT_BAR);
              /*................. TRACER LES RELIQUATS ............*/
              objc_offset(object,EZ_INFO_BOX,&deltx,&delty);
              if (wgrect.g_w<old_wgrect.g_w)
                 {deltgrect.g_x = deltx + object[EZ_INFO_BOX].ob_width;
                  deltgrect.g_y = wgrect.g_y;
                  deltgrect.g_w = wgrect.g_x + wgrect.g_w - deltgrect.g_x;
                  deltgrect.g_h = wgrect.g_h;
                  SendGrectRedrawMessage( w_h, &deltgrect);
                  ExeAllMessage();
                 }
                 
              if (wgrect.g_h<old_wgrect.g_h)
                 {deltgrect.g_x = wgrect.g_x;
                  deltgrect.g_y = delty + object[EZ_INFO_BOX].ob_height;
                  deltgrect.g_w = wgrect.g_w;
                  deltgrect.g_h = wgrect.g_y + wgrect.g_h - deltgrect.g_y;
                  SendGrectRedrawMessage( w_h, &deltgrect);
                  ExeAllMessage();
                 }
              /*........... mettre  jour le rectangle edition texte ........*/
              UpdateParamTexte( object, EZ_INFO_BOX, EZ_ED_GetTxtEditStruct(object, EZ_INFO_BOX));
              /*............sauver param new_extgrect .......................*/
              STDOUT_Grect = new_extgrect;
              if (IsStdoLink)
                 {INT16 wind  = IsWindExist(W_PCSTUDIO);
                  if (wind  != -1)
                     {GRECT  grect = Windtab[wind].ExtGrectUse;
                      Dwx = STDOUT_Grect.g_x - grect.g_x;
                      Dwy = STDOUT_Grect.g_y - grect.g_y;
                     }
                 }
             }break;
             
        case WM_MOVED:  
             STDOUT_Grect = *(GRECT*)& Evnt->pipe[X_G];
             OnWm_moved(w_ind, Evnt);
             if (IsStdoLink)
                {INT16 wind  = IsWindExist(W_PCSTUDIO);
                 if (wind  != -1)
                    {GRECT  grect = Windtab[wind].ExtGrectUse;
                     Dwx = STDOUT_Grect.g_x - grect.g_x;
                     Dwy = STDOUT_Grect.g_y - grect.g_y;
                    }
                }
             break;
        case WM_FULLED: OnWm_fulled( w_ind, Evnt);    break;
             
       } /* end switch message     */
    } /* end if Evnt & MU_MESSAG  */      
 return Evnt->evnt;    /* retourner le flux evenementiel (modifie ou pas)    */
}

/*-------------------- AdjustSTD_OUTToNewGrectWind --------------------------*/
void AdjustSTD_OUTToNewGrectWind(INT16 w_attr, OBJECT *object, GRECT *oldGrect, GRECT *newGrect)
{GRECT old_wgrect,new_wgrect;
 INT16 deltx,delty;

 WindGemBorderToEZWork(w_attr, oldGrect, &old_wgrect);
 WindGemBorderToEZWork(w_attr, newGrect, &new_wgrect);

 deltx = new_wgrect.g_w -  old_wgrect.g_w; 
 delty = new_wgrect.g_h -  old_wgrect.g_h;    
 object[EZ_INFO_VERT_BAR].ob_x           += deltx;
 object[EZ_INFO_VERT_UP].ob_x            += deltx;
 object[EZ_INFO_VERT_DW].ob_x            += deltx;
 /*object[EZ_INFO_BULLE_ON].ob_x           += deltx;*/
 object[EZ_INFO_BOX].ob_width            += deltx;
 object[EZ_INFO_VERT_DW].ob_y            += delty;
 object[EZ_INFO_VERT_BAR].ob_height      += delty;
 object[EZ_INFO_BOX].ob_height           += delty;
              
 object[EZ_INFO_HORZ_BAR].ob_y           += delty;
 object[EZ_INFO_HORZ_LFT].ob_y           += delty;
 object[EZ_INFO_HORZ_RGT].ob_y           += delty;
 object[EZ_INFO_HORZ_RGT].ob_x           += deltx;
 object[EZ_INFO_HORZ_BAR].ob_width       += deltx;
}
/*--------------------------- GoFirstValid --------------------------------*/
char *GoFirstValid(char *pt, char *tojump)
{while (strchr(tojump, *pt)         /* tant que car doit etre saute        */
               && *pt) pt++;        /* et 0 de fin non atteint poursuivre  */
 return pt;
}

/*------------------------ AdjustSrollInfoSlide -----------------------------*/
void AdjustSrollInfoSlide(OBJECT *object)
{GRECT grect;
 INT16 lgnh, clnw, nbl_view, nbc_view;
 long nb_lgn, nb_cln, fstc, fstl, posh, posv;
              
 GetScrollBoxGRECT( object, EZ_INFO_BOX, &grect, -1);
 GetScrollBoxLParam(object, EZ_INFO_BOX, &lgnh, &clnw, &nb_lgn, &nb_cln, &fstl, &fstc, 0, 0, 0, 0);
 nbl_view = grect.g_h / lgnh;
 nbc_view = grect.g_w / clnw;
 SetSlideWidth(object, EZ_INFO_HORZ_BAR,  nb_cln, nbc_view, fstc, MIN_SLIDE_W, HORIZONTAL); 
 SetSlideWidth(object, EZ_INFO_VERT_BAR,  nb_lgn, nbl_view, fstl, MIN_SLIDE_W, VERTICAL);   
 posh = Min(fstc, nb_cln - nbc_view);
 posv = Min(fstl, nb_lgn - nbl_view);
 DocPosToSlidePos(object,  EZ_INFO_HORZ_BAR, nb_cln, nbc_view, posh, HORIZONTAL);
 DocPosToSlidePos(object,  EZ_INFO_VERT_BAR, nb_lgn, nbl_view, posv, VERTICAL);
 SetScrollBoxParam(object, EZ_INFO_BOX,-2,-2,-2,-2, posv, posh, -2,-2,(void*)-2L,-2);
}
/*------------------------ UpdateParamTexte -----------------------------*/
void UpdateParamTexte( OBJECT *object, INT16 ob_ind, TXTED_OB *TXT_A)
{INT16 nbr_l, prm_l;
 /*.................. mettre  jour le rectangle edition texte ..........*/
 GetScrollBoxParam       (object,                     /* adresse de l'arbre dans lequel est l'objet      */
                          ob_ind,                     /* indice de l'objet dans l'arbre                  */
                          &TXT_A->IntLg,              /* hauteur en pixels d'une ligne de scrolling      */
                          0,                          /* largeur en pixels d'une colonne scrolling       */
                          0,                          /* Nombre total de lignes document                 */
                          0,                          /* nombre total de colonnes document               */
                          &prm_l,                     /* indice ligne document  afficher en 1er         */
                          0,                          /* indice colonne document  afficher  gauche     */
                          0,                          /* ligne selectionne ( mettre en surbrillance)   */
                          0,                          /* colonne selectionne ( mettre en surbrillance) */
                          0,                          /* paramtre optionnel  type de pointeur          */
                          &nbr_l                      /* nbr de cases afichables                         */
                         );
 /*.......... updater les parametres de ligne de l'editeur ..............*/                        
 TXT_A->PremLigVisible = prm_l;
 TXT_A->NbreLigVisible = nbr_l;
 /*........... updater le rectangle texte de l'editeur ..................*/
 GetScrollBoxGRECT(object, ob_ind, &TXT_A->TxtGrect, -1);
 /*............. appeler fonction d'update de l'editeur de texte ........*/
 TXT_A->EditTxtPosChg(TXT_A);
}


/*------------------------------- WReadFile -------------------------------*/
void WReadFile(long fp)
{INT16 w_ind          = IsWindExist(W_PEXEC3);
 TXTED_OB  *TXT_A   = 0;
 if (w_ind    != -1)
    {TXT_A    = EZ_ED_GetTxtEditStruct(GETWINDTREE(w_ind), EZ_INFO_BOX);
    }
 if (fp>NULL)
    {char buf[500];
     long size=1L;
     while (size)
      {size=Fread((INT16)fp, 495, buf);
       if (size)
          {buf[size]=0;
           WriteMemFile(buf, size);
           if (TXT_A) AddString(w_ind, buf, TXT_A);
          }
      } /*endwhile (size)*/
    }/*endif (fp>NULL) */
}

/*------------------------------- wprintf ---------------------------------*/
INT16 wprintf( const char *format, ... )
{INT16 w_ind          =  IsWindExist(W_PEXEC3);
 TXTED_OB  *TXT_A   = 0;
 char buf[1024];
 va_list args;
 if (w_ind    != -1)
    {TXT_A    = EZ_ED_GetTxtEditStruct(GETWINDTREE(w_ind), EZ_INFO_BOX);
    }
 va_start( args, format);
 vsprintf(buf, format, args);
 va_end( args);
 if (TXT_A)    
    {AddString(w_ind, buf, TXT_A);
     return 1;
    }
 return 0;
}

/*--------------------------- AddString --------------------------------*/
void AddString(INT16 w_ind, char *txtref, TXTED_OB  *TXT_A)
{long param[4];
 /*............. placer le curseur en fin de texte .....................*/
 /*              et deselectionne le texte                              */
 if (TXT_A==0) return;
 TXT_A->State |= (EDIT_BLK_NOT_AFTER_PASTE|EDIT_SCRLH_NOT_AFTER_PASTE);
 
 param[0] = (long)(TXT_A->EndTxt);
 param[1] = (long)TXT_A;
 EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_CURS_POS, (INT16*)param, 4, TXT_A);
 EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CLEAR_SEL,    (INT16*)param, 4, TXT_A);
 
 param[0] = (long)(txtref);
 param[1] = (long)TXT_A;                 /*  W_G H_G  adresse de l'editeur cible       */
 
 EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_MEMORY_PASTE, (INT16*)param, 4, TXT_A);
 TXT_A->State &= ~(EDIT_BLK_NOT_AFTER_PASTE|EDIT_SCRLH_NOT_AFTER_PASTE);
 /*
 param[0] = (long)(TXT_A->TabLgnCtx[TXT_A->LigPt].ptTxt);
 EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_CURS_POS, (INT16*)param, 4, TXT_A);
 EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CLEAR_SEL,    (INT16*)param, 4, TXT_A);
 */
}

/*------------------------------ get_directory ----------------------------*/
char *get_directory(char *path)
{long len;
 path[0] = 'A' + Dgetdrv();
 path[1] = ':';
 Dgetpath(path+2, 0);
 len = strlen(path);
 if (len>0 && path[len-1] != '\\') strcpy(path + len, "\\");
 return path;
}

/*------------------------------ donne_chemin ----------------------------*/
void donne_chemin(char *path, char *buf)
{strcpy(buf, path);
}

/*------------------------------ my_Dsetpath ------------------------------*/
void my_Dsetpath(char *path)
{if (path[1]==':') Dsetdrv( *path-65 );
 PathNomToNomFic(path, 0);
 chdir(path);
}

/*------------------------ my_Pvfork -------------------------------------*/
long my_Pvfork(void)
{ if (MachineInfo.mult_os == 'MagX') return -1L;
  else                               return Pvfork();
}

/*------------------------ CloseSTD_OUT -------------------------------------*/
void CloseSTD_OUT(void)
{INT16 w_ind = IsWindExist(W_PEXEC3);
 UnLockWindMessage();
 if (w_ind != -1) SendWindMessage(GETGEMHAND(w_ind), WM_CLOSED, 0);
 ExeAllMessage();
 ExeAllMessage();
 ExeAllMessage();
 ExeAllMessage();
 ExeAllMessage();
}


/*------------------------ OpenSTD_OUT -------------------------------------*/
void OpenSTD_OUT(INT16 mode, GRECT *ext_grect)
{INT16 w_ind = IsWindExist(W_PEXEC3);
 mode++;
 if (IsStdoLink&&Dwx!=-32000&&Dwy!=-32000)
    {INT16 wind  = IsWindExist(W_PCSTUDIO);
     if (wind  != -1)
        {GRECT  grect = Windtab[wind].ExtGrectUse;
         ext_grect->g_x = grect.g_x + Dwx ;
         ext_grect->g_y = grect.g_y + Dwy ;
        }
    }
             
 if (w_ind==-1)                 /* << SI existe pas la creer         */
    {/*.............ajuster dans ecran GEM ...................*/     
     CreateWindow(0x8000|SMALLER|CLOSER|NAME|MOVER|BORDER|XBORDER|XMOVER|XSIZER, W_PEXEC3, ext_grect, WindProcPEXEC3, 
                  Mousex() - (450>>1),
                  Mousey() - (300>>1),
                  450,
                  300, "Fenetre STD_OUT");
    }
 else                           /* << SI elle existe                  */
    {if (Windtab[w_ind].w_flag & W_IS_ICON || 
         Windtab[w_ind].w_flag & W_IS_ALLICON
        )
        {UnconifyWindow(w_ind); 
        }
     else if (IsWindOpen(w_ind)>0)     /*        SI ouverte la mettre au top */
        {wind_set(Windtab[w_ind].w_h, WF_TOP, 0, 0, 0, 0);
        }
     else                       /*        SI pas ouverte l'ouvrir     */
        {OpenWindow(w_ind, &Windtab[w_ind].ExtGrectUse);
        } 
    } 
 ExeAllMessage();
 ExeAllMessage();
 ExeAllMessage();
 ExeAllMessage();
 ExeAllMessage();
}